#line 1 "C:/_MickroC/_MesProjets_MickroC/_12F1840/12F1840_Usart_Linvor_131017.c"
#line 1 "c:/program files/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 89 "C:/_MickroC/_MesProjets_MickroC/_12F1840/12F1840_Usart_Linvor_131017.c"
const code char mesg0[]="Mikroc pro 6.0.0 17/10/2013\n\r";
const code char mesg1[]="12F1840 avec BT Linvor\n\r";
const code char * Messages[]={mesg0,mesg1};


unsigned int NbCycles_T0 = 122;


unsigned long NbCycles_T1= 3035 ;

unsigned short error;

volatile unsigned int CptFE,CptOV;

volatile volatile unsigned int Count0;
volatile int Flag_Timer1;
volatile int Flag_Timer0;
volatile int Flag_Buffer;
volatile int Index;
volatile unsigned char c1;
volatile int j;
unsigned int i,k;
unsigned M;
char buffer[32];
char *txt;
char Texte[32];
int res;

void strConstRamCpy(char *dest, const char *source);
void Write_String(char * texte);
void CRLF(void);
void Tempo(unsigned long L);
void interrupt(void) ;
void Init_Timer0(void);


void interrupt(void) org 0x04
{
 if (PIR1.RCIF==1)
 {


 if (RCSTA.OERR==1)
 {
 c1=RCREG;
 RCSTA.CREN = 0 ;
 RCSTA.CREN = 1 ;
 CptOV++;
 }
 if(RCSTA.FERR==1 )
 {
 RCSTA.SPEN = 0 ;
 CptFE++;
 RCSTA.SPEN= 1 ;
 }
#line 156 "C:/_MickroC/_MesProjets_MickroC/_12F1840/12F1840_Usart_Linvor_131017.c"
 c1 = RCREG;
 if ((c1==13)| (Index>31))
 {
 buffer[Index]=0;
 Flag_Buffer=1;
 PIE1.RCIE=0 ;
 }
 else
 {
 buffer[Index]=c1;
 Index++;
 }
 PIR1.RCIF=0 ;
 }
#line 186 "C:/_MickroC/_MesProjets_MickroC/_12F1840/12F1840_Usart_Linvor_131017.c"
 if( INTCON.TMR0IF==1)
 {
 TMR0=0;
 Count0++;


 if (Count0 >NbCycles_T0)
 {
  LATA.F4 =! LATA.F4 ;
 Count0=0;
 TMR0=0;
 Flag_Timer0=1;
 }
 INTCON.TMR0IF=0;
 }

 }

void Write_String(char * texte)
{
while (* texte)
 {
 UART_Write(* texte++);
 }
}


void strConstRamCpy(char *dest, const char *source) {
 while(*source) *dest++ = *source++ ;
 *dest = 0 ;
}

void CRLF()
{
 UART_Write( 13 );
 UART_Write( 10 );
}

 void Tempo(unsigned long L)
 {
 while (L>0) L--;
 }

 void Init_Timer0(void)
 {

 OPTION_REG.PS2=1;
 OPTION_REG.PS1=1;
 OPTION_REG.PS0=1;
 OPTION_REG.PSA=0;
 OPTION_REG.TMR0CS=0;
 INTCON.TMR0IF=0;
 INTCON.TMR0IE=0;
 TMR0= 0 ;
 CPSCON0=0;
 }
#line 263 "C:/_MickroC/_MesProjets_MickroC/_12F1840/12F1840_Usart_Linvor_131017.c"
void main()
{


 OSCCON=0b01111000;
 ANSELA=0;
 ANSELA.ANSA2=1;
 WPUA=0b00000011;
 CM1CON0=0;
 CM1CON1=0;
 CCP1CON=0;


 APFCON=0;
 APFCON.P1BSEL=1;
 APFCON.RXDTSEL=0;
 APFCON.TXCKSEL=0;


 TRISA=0b0000110;

 FVRCON.FVREN=1;
 FVRCON.TSEN=0;
 FVRCON.TSRNG=1;
 FVRCON.CDAFVR1=0;
 FVRCON.CDAFVR0=0;
 FVRCON.ADFVR1=1;
 FVRCON.ADFVR0=1;

 INTCON=0;
 PIR1=0;
 PIR2=0;
 INTCON.PEIE=0;
 INTCON.GIE=0;



 TRISA=0b0000110;
  LATA.F5 =1;

 txt=&Texte[0];
 UART1_Init(9600);
 TXREG=0;
 UART_Write( 12 );
 Tempo(200000);
 Flag_Buffer=0;
 Index=0;
 buffer[0]=0;

 UART_Write_Text("IT UART RA0=Tx RA1=Rx & Timer0 \n\r");
 CRLF();
 Tempo(200000);

 txt=&Texte[0];
 strConstRamCpy(txt,mesg0);

 Write_String(txt);
 txt=&Texte[0];
 strConstRamCpy(txt, Messages[1] );

 Write_String(txt);
 txt=&Texte[0];

 Count0=0;
 Flag_Timer0=0;

 Init_Timer0();
 TMR0=0;

 CRLF();
 Count0=0;

 CptOV=0;
 CptFE=0;
 c1=0;


 ADC_Init();
 ADCON1.ADPREF1= 1;
 ADCON1.ADPREF0= 1;


 RCSTA=0;
 RCSTA.CREN=1;
 RCSTA.SPEN=1;
 c1 = RCREG;









 INTCON.TMR0IE=1;
 INTCON.TMR0IF=0;

 PIR1.TMR1IF=0;
 TMR0=0;

 PIE1.RCIE=1 ;

 PIE1.TMR1IE=0;
 PIE1.RCIE=1 ;
 INTCON.PEIE=1;
 INTCON.GIE=1;


 do
 {
 res=0;
 UART_Write_Text("AT");
 Tempo(200000L);
 UART_Write_Text("AT+VERSION");
 Tempo(250000L);
 if ( Flag_Buffer==1)
 {
 res = strcmp(buffer,"OKlinvorV1.5");
 Flag_Buffer=0;
 c1=0;
 Index=0;
 CptOV=0;
 CptFE=0;

 PIE1.RCIE=1 ;
 }
 }
 while(res!=0);



 j=0;
 k=0;
 CptOV=0;
 Index=0;
 CptFE=0;

 Flag_Buffer=0;
 while(1)
 {
 j++;
 WordToStr(j,txt);
 UART_Write_Text(txt); UART_Write( 9 );
 M=ADC_Get_Sample(2);
 WordToStr(M, txt) ;
 UART_Write_Text(txt); UART_Write( 9 );



 if ( Flag_Buffer==1)
 {
 UART_Write_Text(buffer);
 Flag_Buffer=0;
 c1=0;
 txt=&Texte[0];
 Index=0;
 WordToStr(Index, txt); UART_Write_Text(txt); UART_Write( 9 );

 WordToStr(CptOV, txt) ; UART_Write_Text(txt); UART_Write( 9 );
 WordToStr(CptFE, txt) ; UART_Write_Text(txt); UART_Write( 9 );
 CptOV=0;
 CptFE=0;

 buffer[0]=0;
 PIE1.RCIE=1 ;
 }






 while (Flag_Timer0==0);
 Flag_Timer0=0;
 CRLF();

 }
 }
