/*
18-10-2013
Module BT linvor connect  la place du DS275
PB YCMCU perdu..plus de reponse comande AT => Reste pin 11 module BT
=> retour OK
vitesse 9600
test version.. si repond  la version c'est qu'il n'est pas deja associ
ATTENTION pour s'associ , verifier cot Archos43 s'il est identifiable
duree d'identification limite  120 secondes


23/07/2012
  Modif traitement erreur separees sur COM
  affiche les etats d'erreurs
  Timer1 non utilise

21/07/2012
  Test UART Hardware on RA0 RA1 with interrupt mode
  Test with Timer0 interrup for blinking Led rouge    RA4
  Test with Timer1 interrput for blinking Led Blanche  RA5
  RA2 Analog input ADC2     avec FVR=4.096V
  RA3 MCLR for ICSP

14/07/2012
Pickit2 OK avec  PIC12F1840, il faut choisir la famille 1,8V !!
mode pooling OK , meme avec une trame de 32 caracteres
mode interrupt UART NOT OK .. pas d'appel interruption !!!
mode Timer1 interrupt OK
Impossible non plus de commander la sortie RA2

last update: 22/04/2012
PB avec Pickit2 ??  malgre MAJ firmware et file data
le 12F1840   n'est pas reconnu...

 * Projet :  12F1840_Usart_RA0_RA1_IT_Timer0.mcppi
   SW:       mikroC PRO for PIC   V 5.61
   test fonction uart et timers
   MCU :         PIC12F1840  ehanced type
   Directory :   C:\_MickroC\_MesProjets_MickroC\_12F1840
   Source :      12F1840_Usart_RA0_RA1_Interrupt_Timers.c
   Programmateur tools : PicKit2  (choose 1,8V family!)
   config bits:
   CONFIG1   :$8007 : 0x0984
   CONFIG2   :$8008 : 0x3413
   config vu par Pickit2 :  0984 3413 <- OK
   nota : pas besoin de faire un export pour que l' Hex soit  jour !
          ce qui n'est pas le cas sous MPLAB !
   VDD    : 5,0V    ( from 2,3 to 5,5V)
   horloge  :  interne  16 MHz ... pas de quartz
   Librairies utilisees :
   - built_in.h
   - UART
   - C_String
   - Conversions
   - ADC
   
   pinout :   
   device ID =  01 1011 100
   Calibrations words 8009h & 800Ah
   hex file au format : INHX32   LSB puis MSB
   docu :
 */
   //ac:PIC12F1840_pinout
    // datasheet
        
  /* Hardware
  12F1840
  pin 1     VDD Alim +5V    ATTENTION !!!!!!!!!!!!!!
  pin 2     RA5  output2 -- R1K-- Led Blanche -- +5V
  pin 3     RA4  output1 -- R1K-- Led Rouge -- +5V
  pin 4     RA3/MCLR/VPP -- ICSP Reset
  pin 5     RA2  Analog input  <--
  pin 6     RA1  ICSP Clock  &  input RX ---- 1  DS275 7 ------ 2 TX RS232
  pin 7     RAO  ICSPDAT     &  output TX --- 3  DS275 5 ------ 3 RX RS232
  pin 8     VSS alim 0V
  */

#include "built_in.h"     // for  Hi  Lo ..etc
  
#define TAB 9
#define CLS 12
#define CR 13
#define LF 10

#define Led_Rouge LATA.F4      // RA4
#define Led_Blanche LATA.F5      // RA5
#define clock16    //Mhz

const code char mesg0[]="Mikroc pro 6.0.0 18/10/2013\n\r";
const code char mesg1[]="12F1840 avec BT Linvor\n\r";
const code char * Messages[]={mesg0,mesg1};
// timer0
//unsigned int NbCycles_T0 = 244;     // 244*16.384mS => 4sec
unsigned int NbCycles_T0 = 122;     // 122*16.384mS => 2sec
//unsigned int  NbCycles_T0 = 61;     // 61*16.384mS => 1sec
 // timer1
unsigned long  NbCycles_T1= 3035 ; //65535-62500=3035 @16Mhz et prescaler=8 => 125mS

unsigned short error;
//volatile unsigned int CptErr;
volatile unsigned int  CptFE,CptOV;
//volatile unsigned int Count1;
volatile  volatile unsigned int Count0;
volatile int Flag_Timer1;
volatile int Flag_Timer0;
volatile int Flag_Buffer;
volatile int Index;
volatile  unsigned char c1;
volatile int j;
unsigned int i,k;
unsigned M;
char buffer[32];
char *txt;
char Texte[32];
int res;

void strConstRamCpy(char *dest, const char *source);
void Write_String(char * texte);
void CRLF(void);
void Tempo(unsigned long L);
void interrupt(void) ;
void Init_Timer0(void);
//void Init_Timer1(void);

void interrupt(void)  org 0x04
{
  if (PIR1.RCIF==1)
   {
   // traitement separe des erreurs de COM

    if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
     {
      c1=RCREG;           // efface drapeau OVERRUN
       RCSTA.CREN = 0 ;
       RCSTA.CREN = 1 ;
       CptOV++;
      }
    if(RCSTA.FERR==1 )
    {
     RCSTA.SPEN = 0 ;
     CptFE++;
     RCSTA.SPEN= 1 ;
     }

  
/*   ancien traitement error   OK
   while ((RCSTA.OERR==1)| (RCSTA.FERR==1))
  {
   c1=RCREG;           // efface drapeau OVERRUN
   RCSTA.SPEN=0;       // efface drapeau Frame error
   CptErr=CptErr + 1;
   RCSTA.SPEN=1;
  };
  */

  c1 = RCREG;
  if ((c1==13)| (Index>31))
    {
    buffer[Index]=0;
    Flag_Buffer=1;
    PIE1.RCIE=0 ; // interdit IT Reception UART
    }
    else
    {
   buffer[Index]=c1;
   Index++;
    }
    PIR1.RCIF=0   ;
  }
 /*--- timer 1  -----------------
  if( PIR1.TMR1IF==1)
  {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
        TMR1H= Hi (NbCycles_T1);
        TMR1L= Lo (NbCycles_T1);
        Count1++;
      if (Count1>7)   // 8x125 ms= 1 seconde
       {
          Led_Blanche= !Led_Blanche; // blink RA5
          Count1=0;
          Flag_Timer1=1;
        }
      PIR1.TMR1IF=0;
   }
   */
   // ---- timer 0  --
  if( INTCON.TMR0IF==1)
  {
        TMR0=0;
        Count0++;
       // 16.384 x 61=> 1sec  
       // 16.384mS x 122 => 2 secondes
       if (Count0 >NbCycles_T0)   // 4 seconde
       {
        Led_Rouge=!Led_Rouge; // blink RA4
          Count0=0;
          TMR0=0;
          Flag_Timer0=1;
        }
      INTCON.TMR0IF=0;
   }
   
 }

void Write_String(char * texte)
{
while (* texte)
 {
  UART_Write(* texte++);
 }
}

// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(char *dest, const char *source) {
  while(*source) *dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF()
{
 UART_Write(CR);
 UART_Write(LF);
}

 void Tempo(unsigned long L)
 {
 while (L>0) L--;
 }
 
 void Init_Timer0(void)    // 1 seconde
 {
 
 OPTION_REG.PS2=1;   // prescaler 1/256
 OPTION_REG.PS1=1;
 OPTION_REG.PS0=1;
 OPTION_REG.PSA=0; // prescaler sur Timer0
 OPTION_REG.TMR0CS=0; // source FOSC/4
 INTCON.TMR0IF=0;
 INTCON.TMR0IE=0;    // disable interrupt Timer0
 TMR0= 0 ; //  256 cycles  prescaler=1/256 => 16.384 mS
 CPSCON0=0;
 }
 
 /*
 void Init_Timer1(void)   // 1 seconde
 {
    PIR1.TMR1IF=0;     // Reset Timer1 Flag
    TMR1H= Hi (NbCycles_T1);
    TMR1L= Lo (NbCycles_T1);
    //  TMR1H=0x0B; TMR1L=0xDB; // 65536-62500=3035
    T1GCON=0;
    T1GCON.T1GTM=0;    // Timer1 gate mode disable
    Flag_Timer1=0;
    //Timer1 Clock Source Select->0 (Fosc/4)   Prescale Select->11 (1:8)
    // Timer1 clock disabled, 0,0, Timer1 ON
    T1CON=0b00110001;
    // test  special avec init  0000 du timer1
    // T1CON=0b00000001;    //prescal select=00 => 1/1
     PIE1.TMR1IE=0;  // disable interrupt on PR1=TMR1
  }
*/


void main()
{
                        // voir page 61
  // 0=4xPLL OFF, 1111=IOFS=16Mhz  0=0  00=SCS=config via Conf1 word FOSC<2:0>
  OSCCON=0b01111000;
  ANSELA=0;             // no analog
  ANSELA.ANSA2=1;       // RA2= Analog input
  WPUA=0b00000011;      // weak pull up on RX & TX
  CM1CON0=0;       // disable comparators
  CM1CON1=0;
  CCP1CON=0;       // indispensable pour UART sur RA0
  

  APFCON=0;
  APFCON.P1BSEL=1;    // pour deconnecter de RA0 mais connecte sur RA4 ???!!
  APFCON.RXDTSEL=0;   // RX sur RA1
  APFCON.TXCKSEL=0;   // TX sur RA0
    // RA0 as output for TX , RA1 as input for RX , RA2 as input
    // RA4 et RA5 en sorties  pour leds
  TRISA=0b0000110;

  FVRCON.FVREN=1;       // fixed voltage reference     (voir page 124)
  FVRCON.TSEN=0;        // temperature enable=0;
  FVRCON.TSRNG=1;       // temperature range high   car VDD>3,6V
  FVRCON.CDAFVR1=0;     // Comparator & DAC OFF
  FVRCON.CDAFVR0=0;
  FVRCON.ADFVR1=1;     // ref=4.096V
  FVRCON.ADFVR0=1;
  
   INTCON=0;
   PIR1=0;
   PIR2=0;
   INTCON.PEIE=0;  // disable IT des peripherique voir fig  8.1 p 77
   INTCON.GIE=0;

  // RA0 as  as output for TX , RA1  as input for RX
  // RA4 et RA5 en sorties  pour leds
   TRISA=0b0000110;
   Led_Blanche=1;

   txt=&Texte[0];
   UART1_Init(9600);
   TXREG=0;
   UART_Write(CLS);
   Tempo(200000);       // Wait for cleaning
   Flag_Buffer=0;
   Index=0;
   buffer[0]=0;
  
   UART_Write_Text("IT UART RA0=Tx RA1=Rx & Timer0 \n\r");
   CRLF();
    Tempo(200000);
   
     txt=&Texte[0];
  strConstRamCpy(txt,mesg0);
 //strConstRamCpy(txt, Messages[0] );
   Write_String(txt);
  txt=&Texte[0];
  strConstRamCpy(txt,  Messages[1] );
  //  strConstRamCpy(txt,mesg1);
   Write_String(txt);
      txt=&Texte[0];

   Count0=0;
   Flag_Timer0=0;
   
   Init_Timer0();   // but not started!
   TMR0=0;          // timer0 8 bits => 0  255  sur 8 bits !

   CRLF();
   Count0=0;
   //CptErr=0;
    CptOV=0;
   CptFE=0;
   c1=0;
    //
    
    ADC_Init();
    ADCON1.ADPREF1= 1;  // Vref sur FVR 4.096V
    ADCON1.ADPREF0= 1;


  RCSTA=0;
  RCSTA.CREN=1;  //enable receiver
  RCSTA.SPEN=1;  // serial port Pins Enable
  c1 = RCREG;   // RAZ errors



  // Side effetcs si activation ci dessous , car pres de la limite 2K
  // UART_Write_Text("Lect ADC2 RA2 \n\r");
  // CRLF();
   

   // on arme tout !
     INTCON.TMR0IE=1; // enable IT par Timer0
     INTCON.TMR0IF=0;
    // T1CON.TMR1ON=1;  // lance timer1
     PIR1.TMR1IF=0;
     TMR0=0;          // timer0 8 bits => 0  255  sur 8 bits !

     PIE1.RCIE=1 ; // autorise IT Reception UART
    // PIE1.TMR1IE=1;  // Enable interrupt on PR1=TMR1
     PIE1.TMR1IE=0;
     PIE1.RCIE=1   ;
     INTCON.PEIE=1;  // autorise IT des peripherique voir fig  8.1 p 77
     INTCON.GIE=1;   // Enable all interrupts (timer1 & UART)


   do
   {
    res=0;
    UART_Write_Text("AT");
    Tempo(200000L);
    UART_Write_Text("AT+VERSION");
     Tempo(250000L);
     if ( Flag_Buffer==1)
      {
      res = strcmp(buffer,"OKlinvorV1.5");
      Flag_Buffer=0;
      c1=0;
      Index=0;
      CptOV=0;
      CptFE=0;
     // CptErr=0;
      PIE1.RCIE=1 ; // re-autorise IT Reception UART
      }
    }
   while(res!=0);

  
  
  j=0;
  k=0;
  CptOV=0;
  Index=0;
  CptFE=0;
  //CptErr=0;
  Flag_Buffer=0;
  while(1)
  {
   j++;
   WordToStr(j,txt);
   UART_Write_Text(txt);  UART_Write(TAB);
   M=ADC_Get_Sample(2);  // lecture sur RA2
   WordToStr(M, txt) ;
   UART_Write_Text(txt);  UART_Write(TAB);

//  Wait to flag buffer full or string ended by car=CR=13)0x0D
//  Uart with interrupt
   if ( Flag_Buffer==1)
     {
      UART_Write_Text(buffer);
       Flag_Buffer=0;
       c1=0;
       txt=&Texte[0];
       Index=0;
       WordToStr(Index, txt);  UART_Write_Text(txt);  UART_Write(TAB);
       // WordToStr(CptErr, txt) ; UART_Write_Text(txt);  UART_Write(TAB);
       WordToStr(CptOV, txt) ; UART_Write_Text(txt);  UART_Write(TAB);
       WordToStr(CptFE, txt) ; UART_Write_Text(txt);  UART_Write(TAB);
       CptOV=0;
       CptFE=0;
    //   CptErr=0;
       buffer[0]=0;
       PIE1.RCIE=1 ; // re-autorise IT Reception UART
     }

  // wait end of timer 0
  // clock=16Mhz prescler=1/256  TMR0=0
  // Tempo 3.7 sec  si Count0=200
  // Tempo =1 sec si Count0=61
  // Tempo =2 sec si Count0=122
   while (Flag_Timer0==0);
    Flag_Timer0=0;
   CRLF();

  } // while (1)
 }
 /*
 cot  RA7 TX Emission vers RX du YC-MCU
15:09:33.062>Mikroc pro 6.0.0 17/10/2013
15:09:33.062> 12F1840 avec BT Linvor
15:09:33.062>
15:09:35.500> ATAT+VERSION    1	  786
15:09:37.125>     2	  790
15:09:39.125>     3	  768
15:09:41.125>     4	  767
15:09:43.187>     5	  791
15:09:45.187>     6	  792

cot PIC RA6 Reception de  TX du YC-MCU
OKlinvorV1.5

 Le YC-MCU repond bien si la led rouge YC-MCU clignote
 donc NON appair
 

 0 1 mikroCPIC1618.exe -MSF -DBG -pP12F1840 -LHF -C -Y -DL -O11111114 -fo16 -N"C:\_MickroC\_MesProjets_MickroC\_12F1840\12F1840_Usart_Linvor_2013.mcppi" -SP"C:\Program Files\Mikroelektronika\mikroC PRO for PIC\defs\" -SP"C:\Program Files\Mikroelektronika\mikroC PRO for PIC\Uses\P16_Enh\" -SP"C:\_MickroC\_MesProjets_MickroC\_12F1840\" -SP"C:\_MickroC\mikroC PRO for PIC\defs\" -SP"C:\_MickroC\mikroC PRO for PIC\Uses\P16_Enh\" -SP"E:\_Microchip_Docus\" "12F1840_Usart_Linvor_131017.c" "__Lib_Math.mcl" "__Lib_MathDouble.mcl" "__Lib_System.mcl" "__Lib_Delays.mcl" "__Lib_CString.mcl" "__Lib_Conversions.mcl" "__Lib_ADC.mcl" "__Lib_UART_a01.mcl"
0 1501 Specified search path does not exist: 'C:\_MickroC\mikroC PRO for PIC\defs'
0 1501 Specified search path does not exist: 'C:\_MickroC\mikroC PRO for PIC\Uses\P16_Enh'
0 1139 Available RAM: 240 [bytes], Available ROM: 4096 [bytes]
0 126 All files Preprocessed in 47 ms
0 122 Compilation Started 12F1840_Usart_Linvor_131017.c
0 1004 interrupt handler (interrupt at 0x0004) 12F1840_Usart_Linvor_131017.c
298 1509 Generated baud rate is 19231 bps (error = 0.16 percent) 12F1840_Usart_Linvor_131017.c
401 123 Compiled Successfully 12F1840_Usart_Linvor_131017.c
0 127 All files Compiled in 94 ms
0 1144 Used RAM (bytes): 160 (67%)  Free RAM (bytes): 80 (33%) Used RAM (bytes): 160 (67%)  Free RAM (bytes): 80 (33%)
0 1144 Used ROM (program words): 1014 (25%)  Free ROM (program words): 3082 (75%) Used ROM (program words): 1014 (25%)  Free ROM (program words): 3082 (75%)
0 125 Project Linked Successfully 12F1840_Usart_Linvor_2013.mcppi
0 128 Linked in 109 ms
0 129 Project '12F1840_Usart_Linvor_2013.mcppi' completed: 359 ms
0 103 Finished successfully: 17 oct. 2013, 18:01:56 12F1840_Usart_Linvor_2013.mcppi



*/